<template>
  <div class="relative header-container">
    <div
      :class="[
        'header-login-container relative z-[60]',
        { 'header-full-width-content': isFullIframe },
      ]"
      @mouseover="isFeatureContentEnabled = false"
    >
      <div v-if="auth" class="flex items-center justify-between header-width">
        <div class="text-white text-[11px] font-medium flex">
          <nuxt-link to="/bet-history">
            <span class="mr-2 cursor-pointer">{{ $t("bet_history") }}</span>
          </nuxt-link>
          <nuxt-link to="/my-promotion" v-if="isShowPromotion">
            <span class="mr-2 cursor-pointer">{{ $t("my_promotion") }}</span>
          </nuxt-link>
          <nuxt-link to="/transaction-history">
            <span class="mr-2 cursor-pointer">{{ $t("statement") }}</span>
          </nuxt-link>
          <nuxt-link :to="ROUTES.ACCOUNT.INFO">
            <span class="mr-2 cursor-pointer">{{ $t("account") }}</span>
          </nuxt-link>
          <nuxt-link v-if="referralEnabled && !isV2ReferralEnabled" to="/referral/referral">
            <span class="mr-2 cursor-pointer">{{ $t("referral") }}</span>
          </nuxt-link>
          <nuxt-link v-if="isReferralV2Enabled && isShowReferralPage" to="/referral-v2/information">
            <span class="mr-2 cursor-pointer">{{ $t("referral") }}</span>
          </nuxt-link>
          <nuxt-link to="/messages" class="flex gap-1">
            <span class="cursor-pointer">{{ $t("messages") }}</span>
            <MessagesMessageCount
              v-if="unreadInfo.TotalCount"
              :count="unreadInfo.TotalCount"
              :is-unread="true"
              class="!ml-0"
            ></MessagesMessageCount>
          </nuxt-link>
        </div>
        <div class="flex items-center text-[11px] font-medium text-white">
          <nuxt-link to="/deposit" v-if="isCashPlayer && isShowDepositWithdrawal">
            <el-button
              class="flex items-center justify-center header-btn deposit-withdraw-btn"
            >
              <span class="text-black">{{ $t("deposit_and_withdrawal") }}</span>
            </el-button>
          </nuxt-link>
          <span class="ml-2 mr-2 flex items-center text-[12px]"
            >{{ $t("hi") }},
            {{ username ? username : $t("loading") + "..." }}</span
          >
          <el-button
            class="flex items-center justify-center header-btn btn-auth-header-bg"
          >
            <utils-balance-information :is-suspended="isSuspendedAccount" />
          </el-button>
          <el-button
            class="flex items-center justify-center header-btn btn-auth-header-bg"
            @click="onLogout"
          >
            {{ $t("logout") }}
          </el-button>
        </div>
      </div>
      <div v-else class="flex justify-between w-full items-center">
        <nuxt-link
          to="/register"
          class="flex gap-[5px] items-center pl-[25px]"
        >
          <div>
            <img
              class="h-[20px] w-[20px]"
              :src="
                getAssetImage(
                  'assets/message/icon_joinnow.png'
                )
              "
            />
          </div>
          <div class="text-[var(--text2)] text-xs font-medium">
            {{ $t("join now free") }}
          </div>
        </nuxt-link>
        <div>
          <div v-if="!paymentOption.IsHidden" class="flex items-center payment-option">
            <img
              :src="paymentOption.ImagePath"
              class="mr-2 h-[20px] w-[20px]"
            />
            <span class="text-white text-[11px]">{{ paymentOption.Text }}</span>
          </div>
        </div>
        <div class="header-login-form">
          <el-form
            ref="loginFormRef"
            inline
            :model="loginFormData"
            :validate-on-rule-change="false"
            :rules="loginRules"
            class="flex items-center"
          >
            <el-form-item prop="Username" :show-message="false">
              <el-input
                v-model="loginFormData.Username"
                :disabled="isLoginProccessing"
                type="text"
                :placeholder="$t('username')"
                class="header-login-input"
              />
            </el-form-item>
            <el-form-item prop="Password" :show-message="false">
              <el-input
                v-model="loginFormData.Password"
                :disabled="isLoginProccessing"
                type="password"
                :placeholder="$t('password')"
                class="header-login-input"
              />
            </el-form-item>
            <div class="btn-click-captcha-to-verify">
              <el-form-item
                v-if="!clientCaptcha.IsHidden"
                prop="Captcha"
                :show-message="false"
              >
                <div id="captcha-button">
                  <div id="captcha-pop-up-verify" class="w-full">
                    <template
                      v-if="
                        !captchaErrorMsg.length &&
                        loginFormData.Captcha.length == 5 &&
                        !isDialogVisible
                      "
                    >
                      <div class="relative w-[18px] h-[18px]">
                        <img
                          :src="
                            getAssetImage(
                              'assets/theme/light_flexible_1/desktop/images/menu/captcha-success.png'
                            )
                          "
                          alt="verify icon success"
                          loading="lazy"
                        />
                      </div>
                      <span class="whitespace-nowrap">{{
                        $t("successful_verification")
                      }}</span>
                    </template>
                    <template v-else>
                      <div
                        class="flex items-center justify-center w-full gap-1"
                        @click="isDialogVisible = true"
                      >
                        <div class="relative w-[18px] h-[18px]">
                          <img
                            :src="
                              getAssetImage(
                                'assets/theme/light_flexible_1/desktop/images/menu/capcha.png'
                              )
                            "
                            alt="verify icon"
                            loading="lazy"
                          />
                        </div>
                        <span>{{ $t("click_to_verify") }}</span>
                      </div>
                    </template>
                  </div>
                </div>
              </el-form-item>
            </div>
            <el-button
              type="danger"
              :disabled="isLoginProccessing"
              class="flex items-center justify-center text-[#BCC4D4] header-login-btn"
              @click="submitLogin(loginFormRef)"
            >
              {{ $t("capital_login") }}
            </el-button>
          </el-form>
        </div>
      </div>
    </div>
    <div
      :class="[
        'menu-bar-group flex justify-between h-[68px] z-[60]',
        { 'header-full-width-content': isFullIframe },
      ]"
    >
      <div
        :class="[
          'header-width flex justify-between h-[67px] relative',
          { 'px-5': !isFullIframe },
        ]"
      >
        <div
          v-if="!auth"
          class="absolute register-site flex items-center gap-2 right-[20px] top-[8px] z-[999]"
          @mouseover="isFeatureContentEnabled = false"
        >
          <nuxt-link
            v-if="!register.IsHidden"
            to="/register"
            class="flex items-center register-site"
            :id="ID.SIGNUP"
          >
            <img
              class="h-[14px] w-[14px] pointer-events-none"
              :src="
                getAssetImage(
                  'assets/theme/blue_sbo/desktop/images/icon-square.svg'
                )
              "
            />
            <span class="ml-2 text-[12px] text-secondary pointer-events-none">{{
              $t("join_now")
            }}</span>
          </nuxt-link>
          <nuxt-link
            v-if="!agentCooperation.IsHidden"
            to="/agent-cooperation"
            class="flex items-center"
          >
            <img
              class="h-[14px] w-[14px]"
              :src="
                getAssetImage(
                  'assets/theme/blue_sbo/desktop/images/icon-square.svg'
                )
              "
            />
            <span class="ml-2 text-[12px]">{{ $t("agent_cooperation") }}</span>
          </nuxt-link>
          <div class="forgot-password-form-item">
            <auth-forgot-password-modal />
          </div>
        </div>
        <nuxt-link
          v-if="!logo.IsHidden"
          :to="logo.HyperLink ? `/${logo.HyperLink}` : '/'"
        >
          <div class="logo h-[60px] w-[200px]">
            <img :src="logo.ImagePath" class="w-full h-full" />
          </div>
        </nuxt-link>
        <!-- Menu Bar -->
        <div class="menu-bar relative w-[82%] h-full">
          <ul
            class="flex justify-end items-center absolute bottom-0 h-[42px] w-full font-medium"
          >
            <li
              class="h-full nav-item"
              @mouseover="isFeatureContentEnabled = false"
            >
              <nuxt-link
                v-if="!homeTab.IsHidden"
                class="relative flex items-center h-full p-2 text-inherit inner-border"
                to="/"
                :class="{
                  'active-menu': tabSelected === '/',
                }"
              >
                <img
                  class="home-icon h-[24px] w-[24px]"
                  :class="{
                    hidden: tabSelected === '/',
                  }"
                  :src="HomeIcon"
                />
                <img
                  class="home-icon-active h-[24px] w-[24px]"
                  :class="{
                    hidden: tabSelected !== '/',
                  }"
                  :src="HomeActiveIcon"
                />
                <div class="outer-layer1"></div>
                <div class="outer-layer2"></div>
              </nuxt-link>
            </li>
            <li
              v-for="(tab, index) in menuTabHeaders"
              :key="index"
              class="h-full nav-item"
              @mouseover="
                productListFeatureHover(tab.TabType, tab.TabURL ?? '')
              "
            >
              <nuxt-link
                v-if="tab.TabType === 'Sports' && auth"
                class="relative flex items-center h-full p-2 text-inherit"
                :to="tab.TabURL"
                :id="ID.TAB_TYPE[tab.TabLanguage]"
                :class="{
                  'active-menu':
                    tabSelected === tab.TabURL?.toLowerCase() ||
                    testActiveGame(tab.TabType, activeTab),
                }"
              >
                {{ $t(tab.TabLanguage) }}
              </nuxt-link>
              <nuxt-link
                v-else
                class="relative flex items-center h-full p-2 text-inherit"
                :to="tab.TabURL"
                :id="ID.TAB_TYPE[tab.TabLanguage]"
                :class="{
                  'active-menu':
                    tabSelected === tab.TabURL?.toLowerCase() ||
                    testActiveGame(tab.TabType, activeTab),
                }"
              >
                {{ $t(tab.TabLanguage) }}
                <img
                  v-if="tab.TabIconURL !== ''"
                  :src="tab.TabIconURL"
                  class="ml-1"
                />
              </nuxt-link>
            </li>
            <li
              v-if="isAllowPromotionTab"
              class="h-full nav-item"
              @mouseover="isFeatureContentEnabled = false"
            >
              <nuxt-link
                to="/promotion"
                :class="{ 'active-menu': tabSelected === '/promotion' }"
                class="relative flex items-center h-full p-2 text-inherit hover:hover-header-item"
                :id="ID.TAB_TYPE.PROMOTION"
              >
                {{ $t("promotion") }}
              </nuxt-link>
            </li>
            <li
              v-if="isAppDownloadEnabled"
              class="h-full nav-item"
              @mouseover="isFeatureContentEnabled = false"
            >
              <nuxt-link
                to="/app-download"
                :class="{ 'active-menu': tabSelected === '/app-download' }"
                class="relative flex items-center h-full p-2 text-inherit hover:hover-header-item"
              >
                {{ $t("app_download") }}
              </nuxt-link>
            </li>
          </ul>
        </div>
      </div>
    </div>
    <product-feature-tab-hover
      v-model:is-feature-hover="isFeatureContentEnabled"
      :is-width-customize="true"
      :feature-products="filterProductFeature"
      :component-key="componentKey"
    />
    <div
      :class="[
        'language-datetime px-5',
        { 'header-full-width-content': isFullIframe },
      ]"
    >
      <div class="flex items-center header-width gap-[10px]">
        <lazy-theme-desktop-sbo-components-language></lazy-theme-desktop-sbo-components-language>
        <utils-display-time></utils-display-time>
        <utils-announcement class="sbo-announcement" v-if="!announcement.IsHidden" :announcement="announcement.Text" />
      </div>
    </div>
  </div>
  <div class="double-border">
    <!-- Content -->
  </div>
  <div class="captcha-dialog-container">
    <el-dialog
      v-model="isDialogVisible"
      align-center
      destroy-on-close
      :show-close="false"
      custom-class="p-[15px] captcha-dialog"
      width="320px"
      @open="loginFormData.Captcha = ''"
      @close="loginFormRef?.validateField('Captcha')"
    >
      <utils-client-captcha
        v-if="!clientCaptcha.IsHidden"
        v-model:captcha="loginFormData.Captcha"
        v-model:dialogVisible="isDialogVisible"
        :get-error-message="getCaptchaErrorMsg"
        :is-invalid="captchaErrorMsg.length > 0"
      />
    </el-dialog>
  </div>
</template>

<script lang="ts">
import _ from "lodash";
import { computed, defineComponent, watch, PropType, ref } from "vue";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import {
  useHeaderComponent,
  handleGameEntryOpenWindow,
} from "@/composables/useTheme";
import useLogin from "@/composables/useLogin";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import { clientCaptcha } from "@/composables/captcha/useCaptcha";
import { appStore } from '~~/store/app';
import { store } from "@/store";


export default defineComponent({
  name: "Header",
  props: {
    themeProperties: {
      type: Array as PropType<Array<IThemePropertiesFromApi>>,
      required: true,
    },
  },
  setup(props) {
    const paymentOption = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          props.themeProperties,
          "header_info"
        )
    );
    const logo = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          props.themeProperties,
          "logo"
        )
    );
    const announcement = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          store.state.companyThemePropertiesFromApi.ThemeProperties,
          "announcement"
        )
    );
    const { isShowDepositWithdrawal, isCashPlayer } = useHeaderComponent();
    const { isShowPromotion } = useMenu();
    const isShowReferralPage = computed(() => store.state.IsShowReferralPage);
    const {
      menuTabHeaders,
      tabSelected,
      isAllowPromotionTab,
      isLoading,
      filterProductFeature,
      productListFeatureHover,
      isFeatureContentEnabled,
      auth,
      username,
      isSuspendedAccount,
      logout,
      isAppDownloadEnabled,
      agentCooperation,
      referralEnabled,
      register,
      componentKey,
      isReferralV2Enabled,
      homeTab,
    } = useHeaderComponent();
    const { getAssetImage } = commonHelper;
    const {fetchMessages, unreadInfo } = useMessage();
    const {
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      captchaErrorMsg,
      getCaptchaErrorMsg,
    } = useLogin();
    const onLogout = () => {
      logout();
    };
    const route = useRoute();
    const router = useRouter();
    const activeTab = computed(() => route.query.tab ?? "");
    const testActiveGame = (tabType: string, activeGame: string): boolean => {
      const temTabType = tabType
        .trim()
        .toLowerCase()
        .replaceAll(" ", "")
        .replaceAll("-", "");
      const temActiveGame = activeGame
        .trim()
        .toLowerCase()
        .replaceAll(" ", "")
        .replaceAll("-", "");
      return temActiveGame === temTabType;
    };
    const isDialogVisible = ref(false);
    const HomeActiveIcon = getAssetImage(
      "assets/theme/blue_sbo/desktop/images/icon-home-active.svg"
    );
    const HomeIcon = getAssetImage(
      "assets/theme/blue_sbo/desktop/images/icon-home.svg"
    );
    const routerPush = (url: string): void => {
      if (url) router.push(url);
    };
    const isFullIframe: Ref<boolean> = ref((
      _.find(["saba", "digi", "afb", "bti", "pa"], (item: string) =>
          _.includes(_.toLower(String(route.query.provider)), item)
        ) !== undefined || _.toLower(String(route.query.englishGameName)) === "sbosportsmodern") || 
        route.query.tab === "sports"
    );
    watch(route, () => {
      const providerCheck = _.find(["saba", "digi", "afb", "bti", "pa"], (item: string) =>
          _.includes(_.toLower(String(route.query.provider)), item)
        ) !== undefined;
      const isSboModernDesktop = _.toLower(String(route.query.englishGameName)) === "sbosportsmodern";
      isFullIframe.value = providerCheck || isSboModernDesktop || route.query.tab === "sports";
    });
    onMounted(() => {
      if (!route.fullPath.includes("messages")) {
        fetchMessages();
      }
    });

    return {
      unreadInfo,
      paymentOption,
      logo,
      menuTabHeaders,
      tabSelected,
      isAllowPromotionTab,
      isLoading,
      filterProductFeature,
      productListFeatureHover,
      isFeatureContentEnabled,
      auth,
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      username,
      isSuspendedAccount,
      onLogout,
      isAppDownloadEnabled,
      agentCooperation,
      HomeActiveIcon,
      HomeIcon,
      referralEnabled,
      activeTab,
      testActiveGame,
      EnumEntranceLocation,
      handleGameEntryOpenWindow,
      clientCaptcha,
      isDialogVisible,
      captchaErrorMsg,
      getCaptchaErrorMsg,
      getAssetImage,
      register,
      routerPush,
      isFullIframe,
      componentKey,
      isCashPlayer,
      isShowDepositWithdrawal,
      isShowPromotion,
      isReferralV2Enabled,
      announcement,
      homeTab,
      isShowReferralPage
    };
  },
});
</script>

<style scoped lang="scss">
:deep(.sbo-announcement .text-sm) {
  font-size: 12px;
  color: var(--tertiary);
}
.header-container {
  :deep(.forgot-password-form-item) {
    display: flex;
    align-items: center;
  }
  :deep(.forgot-password-entry) {
    font-style: normal;
    font-weight: 400;
    font-size: 12px;
    line-height: 14px;
    color: var(--secondary);
  }
}
</style>
